    Program g08ajfe

!     G08AJF Example Program Text

!     Mark 24 Release. NAG Copyright 2012.

!     .. Use Statements ..
      Use nag_library, Only: g08ahf, g08ajf, nag_wp
!     .. Implicit None Statement ..
      Implicit None
!     .. Parameters ..
      Integer, Parameter               :: nin = 5, nout = 6
!     .. Local Scalars ..
      Real (Kind=nag_wp)               :: p, pexact, u, unor
      Integer                          :: ifail, lwrk, lwrk1, lwrk2, n1, n2,   &
                                          nsum
      Logical                          :: ties
      Character (1)                    :: tail
!     .. Local Arrays ..
      Real (Kind=nag_wp), Allocatable  :: ranks(:), wrk(:), x(:), y(:)
!     .. Intrinsic Procedures ..
      Intrinsic                        :: int, max
!     .. Executable Statements ..
      Write (nout,*) 'G08AJF Example Program Results'
      Write (nout,*)

!     Skip heading in data file
      Read (nin,*)

!     Read in problem size
      Read (nin,*) n1, n2, tail

!     Calculate sizes of various workspaces
      nsum = n1 + n2

!     Workspace for G08AHF
      lwrk1 = nsum

!     Workspace for G08AJF
      lwrk2 = int(n1*n2/2) + 1

      lwrk = max(lwrk1,lwrk2)
      Allocate (x(n1),y(n2),ranks(nsum),wrk(lwrk))

!     Read in data
      Read (nin,*) x(1:n1)
      Read (nin,*) y(1:n2)

!     Display title
      Write (nout,*) 'Mann-Whitney U test'
      Write (nout,*)

!     Display input data
      Write (nout,99999) 'Sample size of group 1 = ', n1
      Write (nout,99999) 'Sample size of group 2 = ', n2
      Write (nout,*)
      Write (nout,*) 'Data values'
      Write (nout,*)
      Write (nout,99998) '    Group 1  ', x(1:n1)
      Write (nout,*)
      Write (nout,99998) '    Group 2  ', y(1:n2)

!     Perform test
      ifail = 0
      Call g08ahf(n1,x,n2,y,tail,u,unor,p,ties,ranks,wrk,ifail)

!     Calculate exact probababilities
      If (.Not. ties) Then
        ifail = 0
        Call g08ajf(n1,n2,tail,u,pexact,wrk,lwrk,ifail)
      End If

!     Display results
      Write (nout,*)
      Write (nout,99997) 'Test statistic     = ', u
      Write (nout,99997) 'Normal statistic   = ', unor
      Write (nout,99997) 'Tail probability   = ', p
      Write (nout,*)
      If (.Not. ties) Then
        Write (nout,99997) 'Exact tail probability = ', pexact
      Else
        Write (nout,*) &
          'There are ties in the pooled sample so G08AJF was not called.'
      End If

99999 Format (1X,A,I5)
99998 Format (1X,A,8F5.1,2(/14X,8F5.1))
99997 Format (1X,A,F10.4)
    End Program g08ajfe
